/*
 * This source code (.java) file is Copyright  2000 Artima Software, Inc. All rights reserved. 
 * This file accompanies the Jini Place Service Draft Specification, written by Bill
 * Venners and published on the World Wide Web at:
 * 
 *     http://www.artima.com/jini/cyberspace/DraftSpec.html,
 *
 * This source file may not be copied, modified, or redistributed EXCEPT as allowed
 * by the following statements: From August 11, 2000 through December 31, 2000, you may
 * copy and/or modify these files to test and experiment with the Place API,
 * described in the Jini Place Service Draft Specification. Any bug fixes must be given
 * back to Artima Software, Inc. You may not redistribute this file or any binary (such
 * as .class) files generated from this file. You may not distribute modified versions
 * this files or any binary (such as .class) files generated from modified versions of
 * this file. You may not remove this copyright notice. You may not use this file in
 * printed media without the express permission of Bill Venners. And if that weren't
 * enough, you must destroy all copies of this file, and any binary (such as
 * .class) files generated from this file, by December 31, 2000.
 *
 * ARTIMA SOFTWARE, INC. MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THIS SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR PARTICULAR PURPOSE, OR NON-INFRINGEMENT.
 * BILL VENNERS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY A LICENSEE AS A RESULT
 * OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
*/
package com.artima.cyberspace;

import net.artima.place.Link;
import net.artima.place.LinkMap;
import java.util.Map;
import java.util.Set;
import java.util.Collection;

public class BasicLinkMap implements LinkMap {

    private Map map;

    /**
    * Construct a <CODE>BasicLinkMap</CODE>
    */
    public BasicLinkMap(Map map) {

        this.map = map;
    }

    /**
    * Returns the <CODE>Link</CODE> value to which this <CODE>LinkMap</CODE> maps
    * the specified <CODE>Object</CODE> key.
    */
    public Link get(Object key) {

System.out.println("BasicLinkMap: get(" + key.toString() + ")");
if (containsKey(key)) {
    System.out.println(key.toString() + " is contained in map");
}
else {
    System.out.println(key.toString() + " is NOT contained in map");
}
        return (Link) map.get(key);
    }

    /**
    * Returns <CODE>true</CODE> if this <CODE>LinkMap</CODE> contains a mapping for
    * the specified key.
    */
    public boolean containsKey(Object key) {

        return map.containsKey(key);
    }

    /**
    * Returns <CODE>true</CODE> if this <CODE>LinkMap</CODE> maps one or more keys
    * to the specified value.
    */
    public boolean containsValue(Link value) {

        return map.containsValue(value);
    }

    /**
    * Returns <CODE>true</CODE> if this map contains no key-value mappings.
    */
    public boolean isEmpty() {

        return map.isEmpty();
    }

    /**
    * Returns an unmodifiable set view of the keys contained in this map.
    */
    public Set keySet() {

        return map.keySet();
    }

    /**
    * Returns the number of key-value mappings in this map.
    */
    public int size() {

        return map.size();
    }

    /**
    * Returns a collection view of the values contained in this <CODE>LinkMap</CODE>.
    */
    public Collection values() {

        return map.values();
    }

    public Object clone() {

        try {
            return super.clone();
        }
        catch (CloneNotSupportedException e) {
            // This will never happen
        }

        return null;
    }
}
